Attribute VB_Name = "Functions"
DefLng A-Z
Option Explicit

Private TempRed As Long, TempGreen As Long, TempBlue As Long






Private Const CLR_INVALID = &HFFFF
Private Declare Function OleTranslateColor Lib "oleaut32" _
                         (ByVal clr As OLE_COLOR, _
                          ByVal hPal As Long, _
                          dwRGB As Long) As Long


Public Function TranslateColour(ByVal clrColour As OLE_COLOR, _
    Optional hPalette As Long = 0) As Long
  '***********************************************
  '*  TranslateColour
  '*
  '*  This function takes a VB colour constant and
  '*  translates it into its RGB equivalent.
  '***********************************************

  If OleTranslateColor(clrColour, hPalette, TranslateColour) Then
    TranslateColour = CLR_INVALID
  End If

End Function


Public Function ColourToBW(ByVal Colour As Long) As Long
  '***********************************************
  '*  ColourToBW
  '*  ----------
  '*  Convert an RGB colour value to B&W (actually,
  '*  grayscale) equivalent.
  '***********************************************
  If Colour < Zero Then
    Colour = TranslateColour(Colour)
  End If
  SplitIntoRGB Colour, TempRed, TempGreen, TempBlue
  Static TempVal As Long
  TempVal = (TempRed + TempGreen + TempBlue) \ Three
  ColourToBW = RGB(TempVal, TempVal, TempVal)
End Function


Public Function ColourToPaleGray(ByVal Colour As Long) As Long
  '***********************************************
  '*  ColourToPaleGray
  '*  ----------------
  '*  Similar to ColourToBW, but converts to a very
  '*  pale gray equivalent.
  '***********************************************
  If Colour < Zero Then
    Colour = TranslateColour(Colour)
  End If
  SplitIntoRGB Colour, TempRed, TempGreen, TempBlue
  Static TempVal As Long
  TempRed = TempRed + (TwoFiftyFive - TempRed) \ Two
  TempGreen = TempGreen + (TwoFiftyFive - TempGreen) \ Two
  TempBlue = TempBlue + (TwoFiftyFive - TempBlue) \ Two
  TempVal = (TempRed + TempGreen + TempBlue) \ Three
  ColourToPaleGray = RGB(TempVal, TempVal, TempVal)
End Function


Public Sub SplitIntoRGB(ByVal Colour As Long, pRed As Long, pGreen As Long, pBlue As Long)
  '**************************************************************
  '*  SplitIntoRGB
  '*  ------------
  '*  Take an RGB colour value, return the R, G and B components.
  '**************************************************************

  pBlue = Colour \ H10000
  Colour = Colour - pBlue * H10000
  pGreen = Colour \ H100
  Colour = Colour - pGreen * H100
  pRed = Colour

End Sub

