Attribute VB_Name = "Module1"
DefLng A-Z
Option Explicit

Private PointRed_Current() As Long
Private PointGreen_Current() As Long
Private PointBlue_Current() As Long
Private PointRed_Desired() As Long
Private PointGreen_Desired() As Long
Private PointBlue_Desired() As Long
Private img As PictureBox
Private ArrayWidth As Long, ArrayHeight As Long


Public Sub SetupFade(src As PictureBox, dest As PictureBox, ShowFinal As PictureBox)
  Dim X As Long, Y As Long, TempColour As Long
  With src
    ArrayWidth = .ScaleWidth - One
    ArrayHeight = .ScaleHeight - One
    ReDim PointRed_Current(Zero To ArrayWidth, Zero To ArrayHeight)
    ReDim PointGreen_Current(Zero To ArrayWidth, Zero To ArrayHeight)
    ReDim PointBlue_Current(Zero To ArrayWidth, Zero To ArrayHeight)
    ReDim PointRed_Desired(Zero To ArrayWidth, Zero To ArrayHeight)
    ReDim PointGreen_Desired(Zero To ArrayWidth, Zero To ArrayHeight)
    ReDim PointBlue_Desired(Zero To ArrayWidth, Zero To ArrayHeight)
    For Y = Zero To ArrayHeight
      For X = Zero To ArrayWidth
        TempColour = .Point(X, Y)
        If TempColour < Zero Then
          TempColour = TranslateColour(TempColour)
        End If
        SplitIntoRGB TempColour, PointRed_Current(X, Y), PointGreen_Current(X, Y), PointBlue_Current(X, Y)
        
        ' The darker version.
        'SplitIntoRGB ColourToBW(TempColour), PointRed_Desired(X, Y), PointGreen_Desired(X, Y), PointBlue_Desired(X, Y)
        
        ' The lighter version.
        SplitIntoRGB ColourToPaleGray(TempColour), PointRed_Desired(X, Y), PointGreen_Desired(X, Y), PointBlue_Desired(X, Y)
        
        ShowFinal.PSet (X, Y), ColourToPaleGray(TempColour)
      Next
    Next
  End With
  With dest
    .Width = src.Width
    .Height = src.Height
    .ScaleMode = src.ScaleMode
    .ScaleLeft = src.ScaleLeft
    .ScaleWidth = src.ScaleWidth
    .ScaleTop = src.ScaleTop
    .ScaleHeight = src.ScaleHeight
  End With
  Set img = dest
End Sub


Public Sub FadeColour(ByVal FadeSpeed As Long, ColourChanged As Boolean)
  Static I As Long, Difference As Long
  Static X As Long, Y As Long
  ColourChanged = False
  For Y = Zero To ArrayHeight
    For X = Zero To ArrayWidth
      Difference = PointRed_Current(X, Y) - PointRed_Desired(X, Y)
      If Abs(Difference) >= FadeSpeed Then
        PointRed_Current(X, Y) = PointRed_Current(X, Y) - FadeSpeed * Sgn(Difference)
        ColourChanged = True
      ElseIf Abs(Difference) > Zero Then
        PointRed_Current(X, Y) = PointRed_Desired(X, Y)
        ColourChanged = True
      End If
      Difference = PointGreen_Current(X, Y) - PointGreen_Desired(X, Y)
      If Abs(Difference) >= FadeSpeed Then
        PointGreen_Current(X, Y) = PointGreen_Current(X, Y) - FadeSpeed * Sgn(Difference)
        ColourChanged = True
      ElseIf Abs(Difference) > Zero Then
        PointGreen_Current(X, Y) = PointGreen_Desired(X, Y)
        ColourChanged = True
      End If
      Difference = PointBlue_Current(X, Y) - PointBlue_Desired(X, Y)
      If Abs(Difference) >= FadeSpeed Then
        PointBlue_Current(X, Y) = PointBlue_Current(X, Y) - FadeSpeed * Sgn(Difference)
        ColourChanged = True
      ElseIf Abs(Difference) > Zero Then
        PointBlue_Current(X, Y) = PointBlue_Desired(X, Y)
        ColourChanged = True
      End If
      If ColourChanged Then
        img.PSet (X, Y), RGB(PointRed_Current(X, Y), PointGreen_Current(X, Y), PointBlue_Current(X, Y))
      End If
      ' Keeping in mind, of course, that at present the ColourChanged flag
      ' will stay set for the rest of this pass...
    Next
  Next
End Sub

